# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Blogger.V3.Model.BlogPages do
  @moduledoc """
  The container of pages in this blog.

  ## Attributes

  *   `selfLink` (*type:* `String.t`, *default:* `nil`) - The URL of the container for pages in this blog.
  *   `totalItems` (*type:* `integer()`, *default:* `nil`) - The count of pages in this blog.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :selfLink => String.t(),
          :totalItems => integer()
        }

  field(:selfLink)
  field(:totalItems)
end

defimpl Poison.Decoder, for: GoogleApi.Blogger.V3.Model.BlogPages do
  def decode(value, options) do
    GoogleApi.Blogger.V3.Model.BlogPages.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Blogger.V3.Model.BlogPages do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
